var withCreateHash = flight.component(function () {

  'use strict';

  /**
   * Const
   */

  var fixToken = '533589f3-e0dc-44ae-9b8b-1363c0a80a78';
  
  /**
   * Module exports
   */

  return withCreateHash;

  /**
   * Module function
   */

  function withCreateHash() {

	this.createHash = function(evt, data){
		var timestamp = new Date();

		if (data.mode === 'openMethod'){
			return {
				accessToken : $.sha256(fixToken + localStorage.getItem('defaultPrivateToken') + timestamp.getTime()),
				timestamp: timestamp.getTime()
			};
		} else {
			return {
				accessToken : $.sha256(fixToken + localStorage.getItem('privateToken') + timestamp.getTime()),
				timestamp: timestamp.getTime()
			};
		}
	}
	
    this.after('initialize', function () {
    	this.on('dataGetHash', this.createHash);
    });
  }
  
  return withCreateHash;

}());