var Backbutton = flight.component(function () {

  'use strict';

  var history = [{module:'#capture', view:'.category-overview'}],
  	flag = false,
    currentScreen = {module:'#capture', view:'.category-overview'};

  /**
   * Module exports
   */
  //thisComponent.trigger(document, 'saveToHistory', {module: '#capture', view: '.category-overview'});
  return backbutton;

  /**
   * Module function
   */

  function backbutton() {
    this.defaultAttrs({

    });

    this.handleBackbuttonEvent = function(evt, data){
    	if ($('#extra-flyout').css('right') === '0px'){
    		$('#extra-flyout').css('right', '-80%');
    		$('#special-controls .overlay-light').hide();
    		return;
    	}
    	if ($('#help').is(':visible')){
    		if ($('#help header .ui-icon-back').css('visibility') === 'visible'){
    			$('#help header .ui-icon-back').trigger('touchstart').trigger('touchend');
    		} else {
    			$('#help').hide();
    		}
    		return;
    	}

    	if ($('#lifeConstraint').is(':visible')){
    		if (!$('#lifeConstraint .inner-wrapper .teaser').is(':visible')){
    			$('#lifeConstraint footer .col-xs-6 .btn-back').trigger('touchstart').trigger('touchend');
    			return;
    		}
    	}

    	if ($('#change-password').is(':visible')){
    		$('#change-password header').trigger('touchstart').trigger('touchend');
    		return;
    	}

    	if ($('#settings .main').is(':visible')){
    		var target = history.pop();
    		this.backFallback(target.module);
    		return;
    	}

    	if ($('#capturing .popup-container').hasClass('active')){
    		$('#capturing .popup-container').removeClass('active');
    		return;
    	}

    	if ($('#editing .popup-container').hasClass('active')){
    		$('#editing .popup-container').removeClass('active');
    		return;
    	}

    	if ($('#special-controls .overlay').is(':visible')){
    		$('#special-controls .overlay').hide();
    		$('#special-controls .popup').hide();
    		return;
    	}

        if(this.currentScreen){
            var module = this.currentScreen.module;
            var view = this.currentScreen.view;
            switch(view){
                // module capture
                case '.category-overview':
                navigator.app.exitApp();
                break;

                case '.subcategories-wrapper':
                $(module + ' ' + view).trigger('uiGoToBackToMain', {
                    target: '.category-overview'
                });
                break;

                case '#capturing':
                $('#capturing .back-btn').trigger('touchstart').trigger('touchend');
                
                // $('#capturing').trigger('uiBackToDiary', {target: 'capture'});
                return;

                //module edit
                case '#diary': // is in diary trigger MainNavi Capture click
                this.backFallback('#capture');
                // $(module + ' ' + 'header .item:nth-child(0)').first().trigger('uiDoChangeModule', {});;
                break;

                case '#editing':
                $('#editing .back-btn').trigger('touchstart').trigger('touchend');
                if($(module + ' ' + view).hasClass('edited')){
                    return;
                }
                // $('#editing').trigger('uiBackToDiary', {target: 'edit'});
                break;

                // module Export
                case '#pflegestufe': // is in care level screen so go back to summary
                $(view + ' .subheader').trigger('touchend');
                break;

                case '#summary': // is in summary trigger MainNavi Capture click
                this.backFallback('#capture');
                break;

                default:
                this.backFallback('#capture');
                console.log('unknown View');
                break;
            }
        }else{
            var activeModule = utils.getActiveModule();
            switch (activeModule){
                case 'capture':
                navigator.app.exitApp();
                break;

                case 'edit': case 'export': default:
                this.backFallback('#capture');
                break;

              }
              console.log('currentScreen == undefined');
        }
        this.currentScreen = undefined;
    };

    this.backFallback = function(target){
    	switch (target){
		case '#capture':
			if (!$('#capture .category-overview').is(':visible')){
				triggerBackFallback({selector : '#capture header .item', target : 'capture'});
				// $('#capture header .item').first().trigger('touchstart').trigger('touchend');
				// return;
			}

			break;
		case '#export':
			if (!$('#export #summary').is(':visible')){
				triggerBackFallback({selector : '#export header .item', target : 'export'});
				// $('#export header .item').first().next().next().trigger('touchstart').trigger('touchend');
				// return;
			}

			break;
		case '#edit':
			if (!$('#edit #diary').is(':visible')){
				triggerBackFallback({selector : '#edit header .item', target : 'edit'});
				// $('#edit  header .item').first().next().trigger('touchstart').trigger('touchend');
				// return;
			}
			break;
		}
    };

    var triggerBackFallback = function(data){
    	if(data){
    		$(data.selector).each(function(){
    			if($(this).data('target') === data.target){
    				$(this).trigger('touchstart').trigger('touchend');
    				return;
    			}
    		});
    	}
    };

    this.handleSaveToHistory = function(evt, data){
        if(history.length === 0){
            history.push(data);
            return;
        }
    	if (data.module !== history[history.length-1].module || data.view !== history[history.length-1].view){
    		history.push(data);
    	}
    };

    this.handleResetHistory = function(evt, data){
    	history = [{module:'#capture', view:'.category-overview'}];
    };

    this.handleDeleteLastHistoryEntry = function(evt, data){
        if(history.length > 0){
            history.pop()
        }        
    }

    this.handleSetCurrentScreen = function(evt, data){
        if(data){
            this.currentScreen = data;
            console.log(this.currentScreen);
        }
    }

    this.after('initialize', function () {
    	this.on('returnHistory', function(){
    		console.log(history);
    	});
    	this.on('backbutton', this.handleBackbuttonEvent);
    	this.on('saveToHistory', this.handleSaveToHistory);
    	this.on('uiResetHistory', this.handleResetHistory);
        this.on('deleteLastHistoryEntry', this.handleDeleteLastHistoryEntry);
        this.on('setCurrentScreen', this.handleSetCurrentScreen);
    });

  }

}());
