var ChangeModule = flight.component(function () {

  'use strict';

  /**
   * Module exports
   */

  return changeModule;

  /**
   * Module function
   */

  function changeModule() {
    this.defaultAttrs({

    });

    this.handleChangeModule = function(event, el){
    	var $editing = $('#editing'); 
    	var $capturing = $('#capturing');
        var $careLevel = $('#pflegestufe');
    	if ($editing.is(':visible') || $capturing.is(':visible') || $careLevel.is(':visible')){
    		if ($editing.is(':visible')){
                $('#editing .back-btn').trigger('touchstart').trigger('touchend');
    			// $('#editing').trigger('uiBackToDiary', {target: this.$node.attr('data-target')});
                $(document).trigger('setCurrentScreen', constants.moduleEdit());
    		} else if($capturing.is(':visible')) {
    			$('#capturing').trigger('uiBackToDiary', {target: this.$node.attr('data-target')});
                $(document).trigger('setCurrentScreen', constants.moduleCapture());
    		}else{
                $('#pflegestufe .subheader').trigger('touchstart').trigger('touchend');
            }
    	} else {
    		this.doChangeModule();
    	}
    };
    
    this.doChangeModule = function(evt, data){
    	var targetHelper = this.$node.attr('data-target');
    	$('.spinner-overlay').hide();
    	if (targetHelper === 'capture'){
    		if (localStorage.getItem('newDataVersion')){
    			$('#special-controls .overlay').show();
        		$('#special-controls .popup-update-data-version').show();
    		}
    	}
    	
    	if (targetHelper !== 'settings'){
    		$('.module.container-fluid').hide();
    		$('#' + targetHelper).show();
    		$('#extra-flyout').css('right', '-80%');
    		$('#special-controls .overlay-light').hide();

            if(targetHelper === 'edit'){          
                $('#edit').trigger('uiChangeModuleTo');
            }else{
                $('#' + targetHelper).trigger('uiChangeModuleTo');
            }
    		
    		
        	
        	$('.subcategories-wrapper').hide();
    		$('#capturing').attr('class', '').hide();
    		$('#capture .category-overview').show();
    		$('#capturing .capture-property').trigger('uiReset', {key: 'capture'}).removeClass('active activated');
        	$('.subcategory .type-wrapper').height(0);

    		$('#editing').attr('class', '').hide();
    		$('#diary').show();
    		$('#editing .capture-property').trigger('uiReset', {key: 'edit'}).removeClass('active activated');
    		
    		
    	} else {
    		
    		if ($('#extra-flyout').css('right') === '0px'){
    			$('#extra-flyout').css('right', '-80%');
    			$('#special-controls .overlay-light').hide();
    		} else {
    			$('#extra-flyout').css('right', '0px');
    			var naviHeight = utils.getMainNavigationHeight();
    			$('#extra-flyout').css({top : naviHeight + 'px'});
    			$('#special-controls .overlay-light').css({top : naviHeight + 'px'});
    			$('#special-controls .overlay-light').show();
    		}
    	}
        var module = utils.getActiveModule();
        // var careLevel = $('#pflegestufe');
        // if(!careLevel.is(':visible')){
            $(document).trigger('setCurrentScreen', constants.getObjectForModule(module));
        // }
		
		if (targetHelper !== 'summary'){
			//$('#summary').trigger('uiReset');
		}
    };
    
    
    this.after('initialize', function () {
    	
    	this.on('touchstart', this.handleChangeModule);
    	this.on('uiDoChangeModule', this.doChangeModule);
    	
    	var $capturing = $('#capturing');
    	
    	$('#special-controls .overlay-light').unbind('touchend').bind('touchend', function(){
    		$(this).hide();
    		$('#extra-flyout').css('right', '-80%');
    		$('#extra-flyout').css({top : utils.getMainNavigationHeight() + 'px'});
    		
    		if ($('#editing').is(':visible')){
    			$('#editing').trigger('dataBackToSelectionView', {});
    		} else {
    			if ($('#capturing').is(':visible')){
    				$('#capturing').trigger('dataBackToSelectionView', {category: $('#capturing').attr('class').split('-')[1]});
    			}
    		}
    		$('#capturing > header').remove();
    	});
    	
    	document.addEventListener("menubutton", function(){
    		$('#extra-flyout').css('right', '0px');
			$('#special-controls .overlay-light').show();
    	}, false);

    	
    	
    });
    
  }

}());
