var DatePicker = flight.component(function () {

  'use strict';

  /**
   * Const
   */

  var monthsArray = ['01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'];
  //var monthsArray = ['Jan', 'Feb', 'Mär', 'Apr', 'Mai', 'Jun', 'Jul', 'Aug', 'Sep', 'Okt', 'Nov', 'Dez'];
  var monthsLongArray = ['Januar', 'Februar', 'März', 'April', 'Mai', 'Juni', 'Juli', 'August', 'September', 'Oktober', 'November', 'Dezember'];
  var daysArray = ['So', 'Mo', 'Di', 'Mi', 'Do', 'Fr', 'Sa'];

  /**
   * Module exports
   */

  return datePicker;

  /**
   * Module function
   */

  function datePicker() {
    this.defaultAttrs({

    });

    this.handleUiIncreaseDate = function(evt, data){

    };

    this.handleUiDecreaseDate = function(evt, data){

    };

    this.getCurrentDate = function(data){
    	if (data){
    		var dateHelper = new Date(data);
    	} else {
    		var dateHelper = new Date();
    	}

    	var date = new Array();

    	date.push(dateHelper.getHours());
    	date.push(dateHelper.getMinutes());
    	date.push(dateHelper.getDate());
    	date.push(dateHelper.getMonth());
    	date.push(dateHelper.getFullYear());
    	date.push(dateHelper.getDay());

    	this.date = date;
    };

    this.getDateList = function(orientationDate){
    	this.dateList = {};
    	if (orientationDate){
    		this.baseDate = new Date(orientationDate);
    	} else {
    		this.baseDate = new Date();
    	}

    	var dateHelper = this.baseDate;

    	for (var i = 30; i > -8; i--){
    		var dateFieldHelper = new Date (dateHelper - (i * 1000*60*60*24));
    		this.dateList[dateFieldHelper.getTime()] = utils.getDateString(dateFieldHelper);
    	}
    };

    this.setValues = function(evt, data){
    	this.$node.find('header > .value').html('<div class="col-xs-4">' + data.values[0] + ':' + data.values[1] + ' Uhr</div><div class="col-xs-8">' + data.values[2] + '</div>');
    };

    this.initDatePicker = function(evt, data){
    	if (!document.getElementById('sw-wrapper')){
    		var parentHelper = this.$node.parent().attr('id'),
    			timeHelper = this.$node.find('.value .col-xs-4').text().split(':'),
    			dayHelper = this.$node.find('.value .col-xs-8').text().split(' '),
    			dateHelper = dayHelper[1].split('.'),
				currentDate = new Date(dateHelper[2], utils.getMonthFromNameShort(dateHelper[1]), dateHelper[0], timeHelper[0], parseInt(timeHelper[1]));


    		this.getDateList(currentDate);

    		if (this.$node.find('header .value').html()){
          var startTimeNode = this.$node.find('header .value .col-xs-4');
    			var timeHelper = startTimeNode.text().split(':');

    			var startHour = parseInt(timeHelper[0]);
    			var startMinute = parseInt(timeHelper[1]);

    			var dateHelper = this.$node.find('header .value .col-xs-8').text();
    			for(var key in this.dateList){
    				if (this.dateList[key] == dateHelper){
    					var startDate = parseInt(key);
    				}
    			}
    		} else {
    			var startHour = currentDate.getHours();
    			var startMinute = currentDate.getMinutes();
    			var startDate = this.baseDate.getTime();
    		}
    		SpinningWheel.addSlot(['00','01','02','03','04','05','06','07','08','09',10,11,12,13,14,15,16,17,18,19,20,21,22,23], 'center', startHour);
    		SpinningWheel.addSlot(['00','01','02','03','04','05','06','07','08','09',10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59], 'center', startMinute);
    		SpinningWheel.addSlot(this.dateList, 'right', startDate);

    		SpinningWheel.open('#' + parentHelper + ' .start_time .editor.multipleselect');
        // fix of some visual glitches occuring when TextSize differs
        this.$node.find('#sw-frame').css({top : startTimeNode.height() + 2 + 'px'});
        this.$node.find('#sw-slots-wrapper').css({height : this.$node.find('#sw-frame').height()})
        
    		this.setValues('initDatePicker', SpinningWheel.getSelectedValues());
    	}
    };

    this.deprecatedinitDatePicker = function(evt, data){

    	var initialDateSlide = 29;
		var initialHoursSlide = 0;
		var initialMinutesSlide = 0;

    	if (data){
    		var saveName = 'edit';

    		var recordDate = new Date (data.start_time);

    		initialDateSlide += utils.getDaysGap(recordDate, new Date());
    		initialHoursSlide = recordDate.getHours()-1;
    		initialMinutesSlide = recordDate.getMinutes()-1;
    	} else {
    		var saveName = 'capture';
    		this.getCurrentDate();
    		initialHoursSlide = this.date[0] -1;
    		initialMinutesSlide = this.date[1] -1;
    	}


    	var thisComponent = this;
    	var selectorHelper = this.$node.parent().attr('id');
    	this.getDateList();

    	if (!this[saveName + '-swiperTimeHours']){
    		this[saveName + '-swiperTimeHours'] = new Swiper('#' + selectorHelper + ' .start_time .time-hour .swiper-container', {
        		mode: 'vertical',
        		slidesPerView: 'auto',
        		initialSlide:initialHoursSlide,
        		loop:true,
        		loopedSlides: 5,
        		onSlideChangeEnd : function(swiper){
        			thisComponent.date[0] = swiper.activeIndex;
        			thisComponent.trigger('uiUpdateHeader');
        		}
        	});
    	}

    	if (!this[saveName + '-swiperTimeMinutes']){
    		this[saveName + '-swiperTimeMinutes'] = new Swiper('#' + selectorHelper + ' .start_time .time-minutes .swiper-container', {
        		mode: 'vertical',
        		slidesPerView: 'auto',
        		initialSlide:initialMinutesSlide,
        		loop:true,
        		//freeMode:true,
        		//freeModeFluid:true,
        		loopedSlides: 5,
        		onSlideChangeEnd : function(swiper){
        			thisComponent.date[1] = swiper.activeIndex;
        			thisComponent.trigger('uiUpdateHeader');

        		}
        	});
    	}

    	var slidesHelper = this.$node.find('.dates .swiper-slide');

    	for (var i = 0; i < slidesHelper.length; i++ ){

    		if (this.dateList[i]){
    			this.getCurrentDate(this.dateList[i]);
        		var dateHelper = 	'<div class="col-xs-3 day">' + daysArray[this.date[5]] + '</div>' +
        							'<div class="col-xs-3 date">' + (this.date[2] < 10 ? '0' + this.date[2] : this.date[2]) + '.</div>' +
        							'<div class="col-xs-3 month">' + monthsArray[this.date[3]] + '.</div>' +
        							'<div class="col-xs-3 year">' + this.date[4] + '</div>';
    								//++this.swiperTimeYears.activeSlide().innerHTML;

        		slidesHelper[i].innerHTML = dateHelper;
    		}

    	}

    	if (!this[saveName + '-swiperTimeDates']){
    		this[saveName + '-swiperTimeDates'] = new Swiper('#' + selectorHelper + ' .start_time .dates .swiper-container', {
        		mode: 'vertical',
        		slidesPerView: 'auto',
        		//freeMode:true,
        		//freeModeFluid:true,
        		//scrollContainer:true,
        		initialSlide:initialDateSlide,
        		onSlideChangeEnd : function(){
        			var activeDateHelper = thisComponent.$node.find('.swiper-slide-active').next().find('.col-xs-3');
        			thisComponent.date[2] = parseInt(activeDateHelper[1].innerHTML);
        			thisComponent.date[3] = $.inArray(activeDateHelper[2].innerHTML, monthsArray);
        			thisComponent.date[4] = parseInt(activeDateHelper[3].innerHTML);;
        			thisComponent.trigger('uiUpdateHeader');
        		}
        	});
    	}


    	this.setValues();
    };

    this.handleUiReset = function(evt, data){
    	if (document.getElementById('sw-wrapper')){
    		SpinningWheel.destroy();
    	}
    };

    this.initEditDatePicker = function(evt, data){
    	this.initDatePicker(evt, data);
    };

    this.after('initialize', function () {

    	this.on('uiDecreaseDate', this.handleUiDecreaseDate);
    	this.on('uiIncreaseDate', this.handleUiIncreaseDate);
    	this.on('uiUpdateHeader', this.setValues);
    	//this.on('uiInitCapturing', this.initDatePicker);
    	//this.on('uiInitEditing', this.initEditDatePicker);
    	this.on('uiEditProperty', this.initDatePicker);
    	this.on('uiReset', this.handleUiReset);
    });
  }

}());
