var Duration = flight.component(function () {

  'use strict';

  /**
   * Module exports
   */

  return duration;
  /**
   * Module function
   */

  function duration() {
    this.defaultAttrs({

    });


    this.handleUiInitCapturing = function(evt, data){
        var minuteArray = ['00','01','02','03','04','05','06','07','08','09',10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59];
    	if (!document.getElementById('sw-wrapper')){

    		var parentHelper = this.$node.parent().attr('id');
    		if (parentHelper === 'editing' && data){
    			var typeHelper = typesIndex.accomplishmentTypes[data.Accomplishment.accomplishment_type_id].AccomplishmentType;

    			if (typeHelper.individual_standard_duration){
    				this.$node.find('header .advice').html('(individuell)').removeAttr('data-min').removeAttr('data-max');
    			} else {
    				var minDuration = Math.round(typeHelper.standard_duration_min / 60),
    					maxDuration = Math.round(typeHelper.standard_duration_max / 60);
    				this.$node.find('header .advice').html('(' + minDuration + ':00 - ' + maxDuration + ':00 min)').attr('data-min', minDuration).attr('data-max', maxDuration);
    			}
    		}

    		if (this.$node.find('header .value').text() !== '00:00'){
    			var durationHelper = this.$node.find('header .value').text().split(':');

    			var startMinute = parseInt(durationHelper[0]);
    			var startSeconds = parseInt(durationHelper[1]);
    			//var startDate = new Date(this.$node.find('header .value .col-xs-8').text()).getTime();
    		} else {
    			var startMinute = 0;
    			var startSeconds = 0;
    		}

    		SpinningWheel.addSlot(minuteArray, 'center', startMinute);
    		SpinningWheel.addSlot(minuteArray, 'right', startSeconds);
    		SpinningWheel.open('#' + parentHelper + ' .duration .editor.multipleselect .col-xs-5');
    		if (parentHelper !== 'editing'){
    			this.trigger('uiUpdateHeader');
    		}

    	}
    }


    this.deprecatedHandleUiInitCapturing = function(evt, data){
    	var thisComponent = this;
    	var initialMinutesSlide = -1;
		var initialSecondsSlide = -1;
		var saveName = 'capture';

    	if (data){
    		var saveName = 'edit';

    		initialMinutesSlide = Math.floor(data.Accomplishment.duration / 60) -1;
    		initialSecondsSlide = (data.Accomplishment.duration % 60) -1;
    	}

    	var selector = this.$node.parent().attr('id');
    	if (!this[saveName + '-swiperMinutes']){
    		this[saveName + '-swiperMinutes'] = new Swiper('#' + selector + ' .duration .duration-minutes .swiper-container', {
        		mode: 'vertical',
        		slidesPerView: 'auto',
        		initialSlide:initialMinutesSlide,
        		loop:true,
        		loopedSlides: 5,
        		onSlideChangeEnd : function(){
        			thisComponent.trigger('uiUpdateHeader');
        		}
        	});
    	}

    	if (!this[saveName + '-swiperSeconds']){
    		this[saveName + '-swiperSeconds'] = new Swiper('#' + selector + ' .duration .duration-seconds .swiper-container', {
        		mode: 'vertical',
        		slidesPerView: 'auto',
        		initialSlide:initialSecondsSlide,
        		loop:true,
        		loopedSlides: 5,
        		onSlideChangeEnd : function(){
        			thisComponent.trigger('uiUpdateHeader');
        		}
        	});
    	}

    	if (data){
    		thisComponent.trigger('uiUpdateHeader');
    	}
    }

    this.handleUiReset = function(evt, data){
    	clearInterval(this.durationInt);
    	this.$node.removeClass('stop-watch-running active activated');
    	this.$node.find('header .value').text('00:00');
    }

    this.handleUiUpdateDuration = function(evt, data){

    	console.log(data);

    	if (data){
    		var values = data;
    	} else {
    		var values = SpinningWheel.getSelectedValues();
    	}
    	var durationHelper = values.values[0] + ':' + values.values[1],
    		durationCompareHelper = parseInt(values.values[0])*60 + parseInt(values.values[1]);


    	this.$node.find('header > .value').html(durationHelper);

    	if (data && data.defaultRange){
    		var minHelper = parseInt(data.defaultRange[0]) -1,
    			maxHelper = parseInt(data.defaultRange[1]) +1;
    	} else {
    		var minHelper = (parseInt(this.$node.find('header .advice').attr('data-min')) * 60) -1,
    			maxHelper = (parseInt(this.$node.find('header .advice').attr('data-max')) * 60) +1;
    	}

    	if ((durationCompareHelper > minHelper) && (durationCompareHelper < maxHelper)){
			this.$node.find('header .rating').html('&#xe801;');
		} else {
			if (durationCompareHelper >= maxHelper){
				this.$node.find('header .rating').html('&#xe802;');
			} else {
				this.$node.find('header .rating').html('&#xe800;');
			}
		}
    }

    this.after('initialize', function () {
    	//this.on('uiInitCapturing', this.handleUiInitCapturing);
    	this.on('uiInitEditing', this.handleUiInitCapturing);
    	this.on('uiUpdateHeader', this.handleUiUpdateDuration);
    	this.on('uiReset', this.handleUiReset);
    	var thisComponent = this;

    	this.$node.find('header .btn').bind('touchend', function(evt){
    		evt.stopPropagation();
    		switch ($(this).attr('data-target')){
    		case 'start':
    			if (!thisComponent.durationInt){
				    thisComponent.timeStamp=Math.floor(new Date().getTime()/1000);
    				thisComponent.durationInt = setInterval(function(){
						var duration=Math.floor(new Date().getTime()/1000)-thisComponent.timeStamp;
						var durationHelper=[0, 0];

						durationHelper[0]=Math.floor(duration/60);
						durationHelper[1]=duration % 60;


        				thisComponent.$node.find('header .value').html((parseInt(durationHelper[0]) > 9 ? durationHelper[0] : '0' + parseInt(durationHelper[0])) + ':' + (parseInt(durationHelper[1]) > 9 ? durationHelper[1] : '0' + parseInt(durationHelper[1])));
        			}, 1000);

    				thisComponent.$node.addClass('stop-watch-running').removeClass('active activated');

    			} else {
    				clearInterval(thisComponent.durationInt);
    				thisComponent.durationInt = null;
    				thisComponent.$node.removeClass('stop-watch-running');
    			}
    			break;
    		case 'reset':
    			clearInterval(thisComponent.durationInt);
    			thisComponent.$node.find('header .value').html('00:00');
    			thisComponent.durationInt = null;
				thisComponent.$node.removeClass('stop-watch-running');
    		}
    	});

    	this.on('uiEditProperty', this.handleUiInitCapturing);
    });
  }

}());
