var InitCapture = flight.component(function (){

  'use strict';

  /**
   * Module exports
   */

  return initCapture;

  /**
   * Module function
   */

  function initCapture() {
    this.defaultAttrs({
    	categoryTemplateSelector: '.category.template'
    });

    $(document).trigger('setCurrentScreen', {module: '#capture', view: '.category-overview'});

    this.after('initialize', function () {
      $(document).trigger('setCurrentScreen', {module: '#capture', view: '.category-overview'});
     		this.$categoryTemplate = this.select('categoryTemplateSelector').clone();
        	var thisComponent = this;

        	for (var i = 0; i < accTypes.accomplishmentCategories.length; i++){
        		var $category = this.$categoryTemplate.clone();
        		$category.attr('id', 'category-' + accTypes.accomplishmentCategories[i].AccomplishmentCategory.id);
        		$category.find('.title').html(accTypes.accomplishmentCategories[i].AccomplishmentCategory.short_name ? accTypes.accomplishmentCategories[i].AccomplishmentCategory.short_name : accTypes.accomplishmentCategories[i].AccomplishmentCategory.name);
        		$category.removeClass('template');
        		$category.bind('touchstart', function(){
        			var $this = $(this);
        			$this.addClass('active');

        			$this.unbind('touchmove').bind('touchmove', function(){
        				$this.removeClass('active');
        				$this.unbind('touchend');
        			});

        			$this.unbind('touchend').bind('touchend', function(){
        				$this.removeClass('active');
        				thisComponent.trigger('.subcategories-wrapper', 'uiGoToCategory', {
            				target: this.id
            			});
        			});
        		});

        		var iconWrappers = $category.find('.icon');

        		$(iconWrappers[0]).html('&#' + categoryIcons[i].icon_char + ';').addClass('active');

        		/*for (var j = 0; j < accTypes.accomplishmentCategories[i].AccomplishmentSubcategory.length; j++){
        			var iconHelper = accTypes.accomplishmentCategories[i].AccomplishmentSubcategory[j].icon_char
        			if (iconHelper){
        				$(iconWrappers[j]).html('&#' + iconHelper + ';').addClass('active');
        			}
        		}*/
        		this.$node.append($category);
        	}
        	this.select('categoryTemplateSelector').remove();
        	//$('#capture > header').css('margin-top', $('#capture > header').height());
        	$('#category-4 .box .title').removeClass('col-xs-8').addClass('col-xs-12');
        	$('#capture .category-overview').show();
    });
  }

}());
