var SingleChoiceProperty = flight.component(function () {

  'use strict';

  /**
   * Module exports
   */

  return singleChoiceProperty;

  /**
   * Module function
   */

  function singleChoiceProperty() {
    this.defaultAttrs({

    });

    this.handleUiReset = function(){
		this.$node.find('.choices .choice').removeClass('active');
		this.$node.find('.choices .choice').first().addClass('active');
		this.$node.find('header > .value').html('1');
	}
    
    this.handleInitEditing = function(evt, data){
    	this.$node.find('.choices .choice').removeClass('active');
    	this.$node.find('header > .value').html(data.Accomplishment.number_of_assistants);
    	$(this.$node.find('.choice')[data.Accomplishment.number_of_assistants-1]).addClass('active');
    }
    
    this.after('initialize', function () {
    	var thisComponent = this;
    	
    	this.on('uiReset', this.handleUiReset);
    	this.on('uiInitEditing', this.handleInitEditing);
    	
    	this.$node.find('.choices .choice').bind('touchend', function(){
    		thisComponent.$node.find('.choices .choice').removeClass('active');
    		
    		var $this = $(this);
    		thisComponent.$node.parent().addClass('edited');
    		$this.addClass('active');
    		thisComponent.$node.find('header > .value').html($this.text());
    	});
    });
  }

}());