var EditAccomplisment = flight.component(function () {

  'use strict';

  /**
   * Module exports
   */

  return editAccomplisment;

  /**
   * Module function
   */

  function editAccomplisment() {
    this.defaultAttrs({

    });


    this.handleUiInitEditing = function(evt, data){
    	var thisComponent = this;
    	if (!document.querySelector('#editing .accomplishment_type_id .editor .subcategory')){
	    	var classHelper = this.$node.parent().attr('class');
	    	this.$node.find('.editor .subcategory').remove();
	    	this.$node.find('.editor').append($('#' + classHelper + '-subcategories .subcategory').clone());
	    	this.$node.find('.ui-icon.btn-help').remove();
	    	this.$node.find('.type-wrapper').attr('style', '');
	    	this.$node.find('.type').bind('touchstart', function(){
	    		var $this = $(this);
	    		$this.bind('touchend', function(){
	    			thisComponent.$node.parent().attr('data-type-id', $this.attr('id').split('-')[1]);
	    			thisComponent.$node.find('header .value').text($this.find('.title').text());
	    			thisComponent.$node.removeClass('active activated');
	    			thisComponent.$node.find('.editor').attr('style', '');
	    			thisComponent.handleUiUpdateAccomplisment('default', {typeId : $this.attr('id').split('-')[1]});
	    			$this.unbind('touchend');
	    		});

	    		$this.unbind('touchmove').bind('touchmove',function(){
	    			$this.unbind('touchend');
	    		});
	    	});

	    	this.$node.find('.subcategory.single-type').bind('touchstart', function(){
	    		var $this = $(this);
	    		$this.bind('touchend', function(){
	    			thisComponent.$node.parent().attr('data-type-id', $this.attr('data-type-id'));
	    			thisComponent.$node.find('header .value').text($this.find('header .title').text());
	    			thisComponent.$node.removeClass('active activated');
	    			thisComponent.$node.find('.editor').attr('style', '');
	    			thisComponent.handleUiUpdateAccomplisment('default', {typeId : $this.attr('data-type-id')});
	    			$this.unbind('touchend');
	    		});

	    		$this.unbind('touchmove').bind('touchmove',function(){
	    			$this.unbind('touchend');
	    		});
	    	});
    	}

    }

    this.handleUiStartEditing = function(evt, data){

    	var heightHelper = this.$node.find('.subcategory').length * 52 + this.$node.find('.type').length * 52;
    	var viewPortHelper = window.innerHeight - 179;
    	if (heightHelper > viewPortHelper){
    		heightHelper = viewPortHelper;
    		this.$node.find('.editor').css('overflow-y', 'scroll');
    	}
    	this.$node.find('.editor').height(heightHelper);

    }

    this.handleUiReset = function(evt, data){
    	this.$node.find('.editor .subcategory').remove();
    	this.$node.find('.editor').attr('style', '');
    }

    this.handleUiUpdateAccomplisment = function(evt, data){
    	this.$node.parent().addClass('edited');
    	var typeHelper = typesIndex.accomplishmentTypes[data.typeId].AccomplishmentType;

    	if (typeHelper.individual_standard_duration){
			$('#editing .duration header .advice').html('(individuell)').removeAttr('data-min').removeAttr('data-max');
		} else {
			var minDuration = Math.round(typeHelper.standard_duration_min / 60),
				maxDuration = Math.round(typeHelper.standard_duration_max / 60);
			if (minDuration === maxDuration){
				$('#editing .duration header .advice').html('(' + maxDuration + ':00 min)').attr('data-min', minDuration).attr('data-max', maxDuration);
			} else {
				$('#editing .duration header .advice').html('(' + minDuration + ':00 - ' + maxDuration + ':00 min)').attr('data-min', minDuration).attr('data-max', maxDuration);
			}
		}
    	var currentDuration = $('#editing .capture-property.duration > header .value').text().split(':');
    	var dataHelper = {values:[currentDuration[0], currentDuration[1]], defaultRange: [typeHelper.standard_duration_min, typeHelper.standard_duration_max]};
    	$('#editing .capture-property.duration').trigger('uiUpdateHeader', dataHelper);

    }

    this.after('initialize', function () {
    	this.on('uiReset', this.handleUiReset);
    	this.on('uiInitEditing', this.handleUiInitEditing);
    	this.on('uiEditProperty', this.handleUiStartEditing);
    });
  }

}());
