var Popup = flight.component(function () {

  'use strict';

  /**
   * Module exports
   */

  return Popup;

  /**
   * Module function
   */

  function Popup() {
    this.defaultAttrs({

    });
     
    this.handleBackToCategories = function(evt, data){
    	if ($('#extra-flyout').css('right') !== '0px'){
    		if ($('#editing').is(':visible') && !$('#editing').hasClass('edited')){
    			
    			if (data.target){
					
    				switch (data.target){
    				case 'capture':
    					$('#capturing > header').remove();
    					$('header .item').first().trigger('uiDoChangeModule');
    					break;
    				case 'edit':
    					$('#capturing > header').remove();
    					$('header .item:nth-child(2)').first().trigger('uiDoChangeModule', {});
    					break;
    				case 'export':
    					$('#capturing > header').remove();
    					$('header .item:nth-child(3)').first().trigger('uiDoChangeModule', {});
    					break;
    				default:
    					$('#extra-flyout').css('right', '0px');
    					$('#special-controls .overlay-light').show();
    				}
    			} else {
    				this.trigger(this.$node.parent(), 'dataBackToSelectionView', {
    	    			category: this.$node.parent().attr('class').split('-')[1]
    	    		});
    			}
    		} else {
    			this.$node.addClass('active');
    		}
    		
    		this.$node.attr('data-target', '');
        	if (data.target){
        		this.$node.attr('data-target', data.target);
        	}
    	} else {
    		switch (this.$node.attr('data-target')){
			case 'capture':			
				console.log($('header .item').first());
				$('header .item').first().trigger('uiDoChangeModule');
				break;
			case 'edit':
				console.log($('header .item:nth-child(2)').first());
				$('header .item:nth-child(2)').first().trigger('uiDoChangeModule');
				break;
			case 'export':			
				console.log($('header .item:nth-child(3)').first());
				$('header .item:nth-child(3)').first().trigger('uiDoChangeModule');
				break;
			default:
				
				if ($('#extra-flyout').css('right') === '0px'){
					$('#extra-flyout').css('right', '-80%');
					$('#special-controls .overlay-light').hide();
		    		if ($('#editing').is(':visible')){
		    			$('#editing').trigger('dataBackToSelectionView', {});
		    		} else {
		    			var $capturing = $('#capturing');
		    			$('#capturing').trigger('dataBackToSelectionView', {category: $capturing.attr('class').split('-')[1]});
		    		}
		    		$('#capturing > header').remove();
					
				} else {
					$('#extra-flyout').css('right', '0px');
					$('#special-controls .overlay-light').show();
				}
			}
    	}
    };
    
    this.handleBackOptions = function($this){
    	
    }
    
    this.after('initialize', function () {
    	
    	var thisComponent = this;
    	console.log('popup:init');
    	
    	this.on(this.$node.parent(), 'uiBackToCategories', this.handleBackToCategories);
    	this.on(this.$node.parent(), 'uiBackToDiary', this.handleBackToCategories);
    	
    	this.$node.find('.popup-btn').unbind('touchstart').bind('touchstart', function(evt){
    		var $this = $(this);
    		$this.addClass('active');
    		
    		$this.bind('touchmove',function(e){
                if(utils.isTouchMove(evt, e)){
                    $this.unbind('touchend');
                    $this.removeClass('active');
                }
    		});
    		
    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');
    			thisComponent.$node.removeClass('active');
        		
        		if (thisComponent.$node.attr('data-target')){
        			
        			if ($(this).attr('data-option') == 'save'){
        				thisComponent.$node.parent().trigger('uiSaveData');
        			}
        			
        			switch (thisComponent.$node.attr('data-target')){
        			case 'capture':
        				$('#capturing > header').remove();
        				$('header .item').first().trigger('uiDoChangeModule');
        				break;
        			case 'edit':
        				$('#capturing > header').remove();
        				$('header .item:nth-child(2)').first().trigger('uiDoChangeModule', {});
        				break;
        			case 'export':
        				$('#capturing > header').remove();
        				$('header .item:nth-child(3)').first().trigger('uiDoChangeModule', {});
        				break;
        			default:
        				$('#extra-flyout').css('right', '0px');
        				$('#special-controls .overlay-light').show();
        			}
        		} else {
        			thisComponent.trigger(thisComponent.$node.parent(), 'dataBackToSelectionView', {
            			category: thisComponent.$node.parent().attr('class').split('-')[1],
            			dataOption: $(this).attr('data-option'),
            		});
        		}
        	});
    		
    	});
    	
    	
    });
  }

}());
