var Profile = flight.component(function () {

  'use strict';

  /**
   * Module exports
   */

  return profile;

  /**
   * Module function
   */

  function profile() {
    this.defaultAttrs({

    });

    this.handleLogout = function(){
        this.$node.find('input').val('');
    }

    this.handleProfileDataNeeded = function(event, el){
    	var thisComponent = this;
    	$('#special-controls .overlay').show();
    	$('#special-controls .popup-profile').show().find('.btn').unbind('touchstart').bind('touchstart', function(evt){
    		var $this = $(this);

    		$this.addClass('active');
    		$this.unbind('touchmove').bind('touchmove',function(e){
                if(utils.isTouchMove(evt, e)){
                    $this.removeClass('active');
                    $this.unbind('touchend');
                }
    		});

    		$this.unbind('touchend').bind('touchend', function(){
                $this.removeClass('active');
    			$('#special-controls .overlay').hide();
		    	$('#special-controls .popup-profile').hide();
    			if ($this.attr('data-option') === 'yes'){
    				thisComponent.doChangeModule();
    			} else {
    				$('#export').trigger('uiDoExport', {flag:'from-profile-popup'});
    			}
    		});
    	});
    };

    this.doChangeModule = function(evt, data){
    	$('.module.container-fluid').hide();
    	//$('#settings > header .title').html('Profil').show();
    	$('#settings').show().find('.main').hide();
    	$('#profile').show();
    	var naviHeight = utils.getMainNavigationHeight();

    	$('#profile header').css({top : naviHeight + 'px'});

    	var innerWrapperHeight = (window.innerHeight - (naviHeight + $('#profile header').height() + 75));

    	$('#profile').height((window.innerHeight - naviHeight) * 0.9);
    	$('#profile .inner-wrapper').css({top : naviHeight + 'px', height : innerWrapperHeight + 'px'});
    	$('.subcategories-wrapper').hide();
	    $('#capturing').attr('class', '').hide();
	    $('#capture .category-overview').show();
	    $('#capturing .capture-property').trigger('uiReset', {key: 'capture'}).removeClass('active activated');
    	$('.subcategory .type-wrapper').height(0);
	    $('#editing').attr('class', '').hide();
      $('#diary').show();
	    $('#editing .capture-property').trigger('uiReset', {key: 'edit'}).removeClass('active activated');
    };

    this.saveProfileData = function(){

    	var exportBody = JSON.parse(localStorage.getItem('exportBody')),
    	    birthdateHelper = this.$node.find('.cared input[name="birthday-year"]').val() + '-' + this.$node.find('.cared input[name="birthday-month"]').val() + '-' + this.$node.find('.cared input[name="birthday-day"]').val();

    	exportBody.CaredPerson.name = this.$node.find('.cared input[name="name"]').val();
    	exportBody.CaredPerson.firstname = this.$node.find('.cared input[name="firstname"]').val();

    	if (this.$node.find('.cared input[name="birthday-year"]').val() === '' || this.$node.find('.cared input[name="birthday-month"]').val() === '' || this.$node.find('.cared input[name="birthday-day"]').val() === ''){
    		exportBody.CaredPerson.birthdate = '';
    	} else {
    		exportBody.CaredPerson.birthdate = this.$node.find('.cared input[name="birthday-year"]').val() + '-' + this.$node.find('.cared input[name="birthday-month"]').val() + '-' + this.$node.find('.cared input[name="birthday-day"]').val();
    	}

    	exportBody.CaredPerson.street = this.$node.find('.cared input[name="street"]').val();
    	exportBody.CaredPerson.city = this.$node.find('.cared input[name="city"]').val();

    	exportBody.CaringPerson.name = this.$node.find('.caring input[name="name"]').val();
    	exportBody.CaringPerson.firstname = this.$node.find('.caring input[name="firstname"]').val();
    	localStorage.setItem('exportBody', JSON.stringify(exportBody));
		$('#data-saved-helper').html('Profil wurde gespeichert.').css('bottom', '0px');
    	setTimeout(function(){
    		$('#data-saved-helper').css('bottom', '-50px');
    		$(document).trigger('backbutton');
    	},1000);
    };


    this.after('initialize', function () {
    this.on('uiDoChangeModule', this.doChangeModule);
    this.on('uiProfileDataNeeded', this.handleProfileDataNeeded);
    this.on('uiLogout', this.handleLogout);

    	var exportBodyHelper = localStorage.getItem('exportBody'),
    		thisComponent = this;

    	if (exportBodyHelper){
    		exportBodyHelper = JSON.parse(exportBodyHelper);

    		this.$node.find('.cared input[name="name"]').val(exportBodyHelper.CaredPerson.name);
        	this.$node.find('.cared input[name="firstname"]').val(exportBodyHelper.CaredPerson.firstname);
        	var birthDateHelper = exportBodyHelper.CaredPerson.birthdate.split('-');
        	if (birthDateHelper.length === 3){
        		this.$node.find('.cared input[name="birthday-year"]').val(birthDateHelper[0]) + '-' + this.$node.find('.cared input[name="birthday-month"]').val(birthDateHelper[1]) + '-' + this.$node.find('.cared input[name="birthday-day"]').val(birthDateHelper[2]);
        	}
        	this.$node.find('.cared input[name="street"]').val(exportBodyHelper.CaredPerson.street);
        	this.$node.find('.cared input[name="city"]').val(exportBodyHelper.CaredPerson.city);

        	this.$node.find('.caring input[name="name"]').val(exportBodyHelper.CaringPerson.name);
        	this.$node.find('.caring input[name="firstname"]').val(exportBodyHelper.CaringPerson.firstname);
    	}

    	$('#extra-flyout .profile').bind('touchstart', function(){
    		var $this = $(this);

    		$this.addClass('active');

    		$this.unbind('touchmove').bind('touchmove',function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});

    		$this.unbind('touchend').bind('touchend', function(){
    			$this.removeClass('active');

    			thisComponent.doChangeModule();
    			$('#extra-flyout').css('right', '-80%');
    			$('#special-controls .overlay-light').hide();
    		});
    	});

    	this.$node.find('footer .btn').bind('touchstart', function(){
    		var $this = $(this);

    		$this.addClass('active');

    		$this.unbind('touchmove').bind('touchmove',function(){
    			$this.removeClass('active');
    			$this.unbind('touchend');
    		});

    		$this.unbind('touchend').bind('touchend', function(){
    			thisComponent.saveProfileData();
    			$this.removeClass('active');
    		});
    	});

    	this.$node.find('input').unbind('focus').bind('focus', function(){
    		$(this).css('text-align', 'left');
    	});



    });

  }

}());
